/*
 * File:   main.c
 * Author: pehladik
 */

#include <stdio.h>
#include <errno.h>
#include "hippo.h"
#include "hippo_app_functions.h"
#include <sys/time.h>


struct timespec prev;
struct timespec now;
/*
* Function linked to the task t
*/
int print(int idCaller, int value) {
    clock_gettime(CLOCK_REALTIME, &now);
    long double diff = ((long double)now.tv_sec + 1.0e-9*now.tv_nsec) -
                       ((long double)prev.tv_sec + 1.0e-9*prev.tv_nsec);
    long int sec = (long int)diff;
    long double nsec = (diff-(long double)sec) *1000L;
    printf("*************************************************\n");
    printf("*****   CALL PERIODIC HELLO WORLD from %d  *******\n", idCaller);
    printf("*****   value %d  *******\n", value);
    printf("*****   Period of %ld s %.03Lf msec\n", sec, nsec);
    printf("*************************************************\n");
    prev = now;
    return value + 1;
}


/*
 *
 */
int main(int argc, char** argv) {
    clock_gettime(CLOCK_REALTIME, &prev);
    clock_gettime(CLOCK_REALTIME, &now);
    engine_run();
    return (EXIT_SUCCESS);
}
